---

- name: Install basics
  apt:
    name: "{{ outer_item }}"
    state: present
  loop:
    - curl
    - ca-certificates
    - tzdata
    - perl
    - cifs-utils
    - unzip
  loop_control:
    loop_var: outer_item

- name: Add gitlab-runner GPG apt Key
  apt_key:
    url: https://packages.gitlab.com/gpg.key
    state: present

- name: Set os related tasks
  include_tasks: "{{ outer_item }}"
  with_first_found:
    - "prereq/{{ ansible_distribution }}.yml"
    - "prereq/default.yml"
  loop_control:
    loop_var: outer_item

- name: Install gitlab-runner
  apt:
    name: gitlab-runner
    state: present

- name: Copy config.toml
  copy:
    src: "{{ ansible_hostname }}.toml"
    dest: /etc/gitlab-runner/config.toml
    owner: root
    group: root
    mode: 0644
  notify:
    - restart_runner
 
- name: Copy id_rsa
  copy:
    src: id_rsa
    dest: /etc/gitlab-runner/id_rsa
    owner: root
    group: root
    mode: 0600

- name: Copy auth.json
  copy:
    src: auth.json
    dest: /etc/gitlab-runner/auth.json
    owner: root
    group: root
    mode: 0600

- name: Give gitlab-runner sudo access
  copy:
    dest: /etc/sudoers.d/gitlab-runner
    content: 'gitlab-runner ALL=(ALL) NOPASSWD: ALL'
    validate: /usr/sbin/visudo -cf %s
    owner: root
    group: root
    mode: 0440
  when: ansible_distribution in ['Ubuntu']

- name: Give gitlab-runner docker access
  user:
    name: gitlab-runner
    groups: docker
    append: yes
  notify:
    - restart_runner

- name: Give gitlab-runner root access
  user:
    name: gitlab-runner
    groups: root
    append: yes
  notify:
    - restart_runner
  when: ansible_distribution in ['Debian']

- name: Enable gitlab-runner service
  systemd:
    name: gitlab-runner.service
    state: started
    enabled: yes
 
